  
//
//  vmpCoreEx.h - 3D Math Core Header
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#ifndef __vmp3DEx_H
#define __vmp3DEx_H

#ifdef __cplusplus
extern "C" {
#endif




bool vmp_IsVEqualGeneric( const vmp3DVector * const pvA, const vmp3DVector * const pvB, float fPrecision );

bool vmp_IsQVEqualGeneric(  const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, float fPrecision );
bool vmp_IsQVEqualAsm3DNow( const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, float fPrecision );
bool vmp_IsQVEqualAsmSSE(   const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, float fPrecision );

bool vmp_IsQuatEqualGeneric(const vmpQuat * const pqA, const vmpQuat * const pqB, float fPrecision);

bool vmp_IsMatrixEqualGeneric(  vmp3DMatrix aMx, vmp3DMatrix bMx, float fPrecision);
bool vmp_IsMatrixEqualAsm3DNow( vmp3DMatrix aMx, vmp3DMatrix bMx, float fPrecision);
bool vmp_IsMatrixEqualAsmSSE(   vmp3DMatrix aMx, vmp3DMatrix bMx, float fPrecision);




#ifdef __cplusplus
}
#endif

#endif  //__vmp3DEx_H


