        TITLE   vmp3DX86.inc - 80(x)86 3D Math
        PAGE    53,160

;  Vmp3D.inc - 3D Math Addition & Subtraction
;
;  This document contains file that you may use at your own risk in your own programs.
;
;  This module is designed to accomodate the book.
;
;               This module is designed for fast 3D math
;
;  Created - 3 Oct 2001 - James Leiterman
;
;  Last Modification
;
;       Tabs = 8


ifndef __vmp3DX86Inc
__vmp3DX86Inc   equ     1


PI      =       040490fdch              ; (3.141593)

FLOAT1  =       03f800000h              ; (+1.0f)
FLOAT0  =       0                       ; ( 0.0f)
FLOAT_1 =       0bf800000h              ; (-1.0f)
FLOAT0001 =     038d1b717h              ; (0.0001f)



;
; 3D Coordinate (Single Precision Floating Point)
;

vmp3DVector STRUCT
        x       REAL4 ? ;float  ?
        y       REAL4 ? ;float  ?
        z       REAL4 ? ;float  ?
vmp3DVector ends



;
; 3D Coordinate Quad Vector (Single Precision Floating Point)
;

vmp3DQVector STRUCT
        x       REAL4 ? ;float  ?
        y       REAL4 ? ;float  ?
        z       REAL4 ? ;float  ?
        w       REAL4 ? ;float  ?
vmp3DQVector ends




;
;       Texture Coordinate
;

vmp3DVertex STRUCT
        x       REAL4 ?
        y       REAL4 ?
        z       REAL4 ?

        nx      REAL4 ?                 ; Normal X-coord.
        ny      REAL4 ?                 ; Normal Y-coord.
        nz      REAL4 ?                 ; Normal Z-coord.

        tu      REAL4 ?                 ; Texture U-coord.
        tv      REAL4 ?                 ; Texture V-coord.
vmp3DVertex ends


;
;  3D Matrix (1 base)
;

vmp3DMatrix1 STRUCT
        _11     REAL4 ?
        _12     REAL4 ?
        _13     REAL4 ?
        _14     REAL4 ?
        _21     REAL4 ?
        _22     REAL4 ?
        _23     REAL4 ?
        _24     REAL4 ?
        _31     REAL4 ?
        _32     REAL4 ?
        _33     REAL4 ?
        _34     REAL4 ?
        _41     REAL4 ?
        _42     REAL4 ?
        _43     REAL4 ?
        _44     REAL4 ?
vmp3DMatrix1 ends

;
;  3D Matrix (0 base)
;

vmp3DMatrix0 STRUCT
        _00     REAL4 ?
        _01     REAL4 ?
        _02     REAL4 ?
        _03     REAL4 ?
        _10     REAL4 ?
        _11     REAL4 ?
        _12     REAL4 ?
        _13     REAL4 ?
        _20     REAL4 ?
        _21     REAL4 ?
        _22     REAL4 ?
        _23     REAL4 ?
        _30     REAL4 ?
        _31     REAL4 ?
        _32     REAL4 ?
        _33     REAL4 ?
vmp3DMatrix0 ends           



;
;  3D Matrix
;

vmp3DMatrix STRUCT
        _m00    REAL4 ?
        _m01    REAL4 ?
        _m02    REAL4 ?
        _m03    REAL4 ?
        _m10    REAL4 ?
        _m11    REAL4 ?
        _m12    REAL4 ?
        _m13    REAL4 ?
        _m20    REAL4 ?
        _m21    REAL4 ?
        _m22    REAL4 ?
        _m23    REAL4 ?
        _m30    REAL4 ?
        _m31    REAL4 ?
        _m32    REAL4 ?
        _m33    REAL4 ?
vmp3DMatrix ends            

if 0
                float m[4][4];          // [row][col]
endif



OFLOW_FIXUP     MACRO   arg1
if OFLOW_TEST eq 1
        mov     eax,DWORD PTR arg1
        ; Normalize, sincos can only handle -1 to +1 for sine and cosine
        ; 03F800000h = 1.0f  0BF800000h=-1.0
        and     eax,07F800000h
        cmp     eax,07F800000h          ;Check for an non-zero exponent!
        jne     $ok

        mov     eax,DWORD PTR arg1
        call    FixupReal4
$ok:   ; ST(0)= value
endif
endm




endif   ; __vmp3DX86Inc


